// Code generated by goa v3.8.5, DO NOT EDIT.
//
// policy client HTTP transport
//
// Command:
// $ goa gen
// gitlab.com/gaia-x/data-infrastructure-federation-services/tsa/policy/design

package client

import (
	"context"
	"net/http"

	goahttp "goa.design/goa/v3/http"
	goa "goa.design/goa/v3/pkg"
)

// Client lists the policy service endpoint HTTP clients.
type Client struct {
	// Evaluate Doer is the HTTP client used to make requests to the Evaluate
	// endpoint.
	EvaluateDoer goahttp.Doer

	// Lock Doer is the HTTP client used to make requests to the Lock endpoint.
	LockDoer goahttp.Doer

	// Unlock Doer is the HTTP client used to make requests to the Unlock endpoint.
	UnlockDoer goahttp.Doer

	// RestoreResponseBody controls whether the response bodies are reset after
	// decoding so they can be read again.
	RestoreResponseBody bool

	scheme  string
	host    string
	encoder func(*http.Request) goahttp.Encoder
	decoder func(*http.Response) goahttp.Decoder
}

// NewClient instantiates HTTP clients for all the policy service servers.
func NewClient(
	scheme string,
	host string,
	doer goahttp.Doer,
	enc func(*http.Request) goahttp.Encoder,
	dec func(*http.Response) goahttp.Decoder,
	restoreBody bool,
) *Client {
	return &Client{
		EvaluateDoer:        doer,
		LockDoer:            doer,
		UnlockDoer:          doer,
		RestoreResponseBody: restoreBody,
		scheme:              scheme,
		host:                host,
		decoder:             dec,
		encoder:             enc,
	}
}

// Evaluate returns an endpoint that makes HTTP requests to the policy service
// Evaluate server.
func (c *Client) Evaluate() goa.Endpoint {
	var (
		encodeRequest  = EncodeEvaluateRequest(c.encoder)
		decodeResponse = DecodeEvaluateResponse(c.decoder, c.RestoreResponseBody)
	)
	return func(ctx context.Context, v interface{}) (interface{}, error) {
		req, err := c.BuildEvaluateRequest(ctx, v)
		if err != nil {
			return nil, err
		}
		err = encodeRequest(req, v)
		if err != nil {
			return nil, err
		}
		resp, err := c.EvaluateDoer.Do(req)
		if err != nil {
			return nil, goahttp.ErrRequestError("policy", "Evaluate", err)
		}
		return decodeResponse(resp)
	}
}

// Lock returns an endpoint that makes HTTP requests to the policy service Lock
// server.
func (c *Client) Lock() goa.Endpoint {
	var (
		decodeResponse = DecodeLockResponse(c.decoder, c.RestoreResponseBody)
	)
	return func(ctx context.Context, v interface{}) (interface{}, error) {
		req, err := c.BuildLockRequest(ctx, v)
		if err != nil {
			return nil, err
		}
		resp, err := c.LockDoer.Do(req)
		if err != nil {
			return nil, goahttp.ErrRequestError("policy", "Lock", err)
		}
		return decodeResponse(resp)
	}
}

// Unlock returns an endpoint that makes HTTP requests to the policy service
// Unlock server.
func (c *Client) Unlock() goa.Endpoint {
	var (
		decodeResponse = DecodeUnlockResponse(c.decoder, c.RestoreResponseBody)
	)
	return func(ctx context.Context, v interface{}) (interface{}, error) {
		req, err := c.BuildUnlockRequest(ctx, v)
		if err != nil {
			return nil, err
		}
		resp, err := c.UnlockDoer.Do(req)
		if err != nil {
			return nil, goahttp.ErrRequestError("policy", "Unlock", err)
		}
		return decodeResponse(resp)
	}
}
